0
00:00:04,970 --> 00:00:07,220
ДУГ ЛЛОЙД: Отже, якщо ви бачили наше відео про структури,

1
00:00:07,220 --> 00:00:10,950
Ви вже знаєте, що ми маємо можливість визначати власні типи даних.

2
00:00:10,950 --> 00:00:14,530
Але якщо ви користувалися структурами, ви знаєте, що іноді використовуються ці типи даних

3
00:00:14,530 --> 00:00:16,446
насправді може бути трохи громіздким, тому що ми

4
00:00:16,446 --> 00:00:19,210
потрібно використовувати ключове слово struct, коли ми працюємо з ними--

5
00:00:19,210 --> 00:00:21,257
struct car або struct student.

6
00:00:21,257 --> 00:00:23,090
Це дуже багато для друку, якщо ми просто хочемо мати

7
00:00:23,090 --> 00:00:24,830
щось просте, як структура.

8
00:00:24,830 --> 00:00:26,390
Ми хочемо мати-- ми хочемо мати можливість працювати з речами

9
00:00:26,390 --> 00:00:29,350
трохи більш скорочений спосіб, як int або char, щось багато

10
00:00:29,350 --> 00:00:31,240
зручніше друкувати.

11
00:00:31,240 --> 00:00:33,100
>> На щастя, є спосіб зробити це в C,

12
00:00:33,100 --> 00:00:37,150
з чимось під назвою typedef, який є способом створення скорочення або переписання

13
00:00:37,150 --> 00:00:38,640
назви типів даних.

14
00:00:38,640 --> 00:00:40,720
Ви можете переписати типи даних, які вже існують,

15
00:00:40,720 --> 00:00:43,970
або ви можете написати власні типи даних.

16
00:00:43,970 --> 00:00:46,890
>> Перше, що ви робите, це визначаєте тип звичайним способом,

17
00:00:46,890 --> 00:00:52,271
а потім ви просто надаєте йому псевдонім на щось інше-- typedef старе ім’я нове ім’я.

18
00:00:52,271 --> 00:00:53,520
Досить просто, правда?

19
00:00:53,520 --> 00:00:56,240
Таким чином, ми могли б ввести, наприклад, уже існуючі дані

20
00:00:56,240 --> 00:01:00,266
тип беззнакового символу як байт.

21
00:01:00,266 --> 00:01:03,140
І потім, відтепер, після того як ми зробили це визначення типу-- знову,

22
00:01:03,140 --> 00:01:07,570
який зазвичай буде у верхній частині наших файлів із крапкою C або у файлі з крапкою H

23
00:01:07,570 --> 00:01:10,590
окремо, ми можемо просто використовувати bite всюди

24
00:01:10,590 --> 00:01:12,180
ми б використали unsigned char.

25
00:01:12,180 --> 00:01:14,300
Це набагато коротше для друку.

26
00:01:14,300 --> 00:01:19,280
>> У бібліотеці CS50 ми робимо це-- ми вводимо char star як рядок.

27
00:01:19,280 --> 00:01:21,400
Тому що ми абстрагувалися від ідеї вказівників.

28
00:01:21,400 --> 00:01:25,072
І той факт, що рядок насправді є вказівником на перший символ--

29
00:01:25,072 --> 00:01:26,780
набір символів, тому що це просто

30
00:01:26,780 --> 00:01:29,863
так заплутано розібратися в цьому, але насправді це те, що ми робимо.

31
00:01:29,863 --> 00:01:35,140
І цей рядок коду насправді існує в CS50 dot H typedef char star string,

32
00:01:35,140 --> 00:01:39,021
просто щоб зробити це трохи менш громіздким.

33
00:01:39,021 --> 00:01:41,520
Ви, мабуть, уже трохи переконалися в цьому,

34
00:01:41,520 --> 00:01:44,160
але typedef стає чудовим у поєднанні зі структурами,

35
00:01:44,160 --> 00:01:45,780
як я згадував раніше.

36
00:01:45,780 --> 00:01:48,550
Структури мають назву типу з двох слів.

37
00:01:48,550 --> 00:01:52,020
Тому створювати змінні такого типу може бути дуже неприємно,

38
00:01:52,020 --> 00:01:56,310
або [НЕРОЗБІРНО] struct something, ваші рядки можуть стати дуже, дуже довгими.

39
00:01:56,310 --> 00:01:59,400
І тому ви можете використовувати typedef, щоб придумати щось набагато коротше.

40
00:01:59,400 --> 00:02:04,650
>> Отже, якщо я визначу автомобіль наступним чином, я маю своє визначення автомобіля-- struct car,

41
00:02:04,650 --> 00:02:07,230
а потім відкрити фігурну дужку, усі поля моєї структури,

42
00:02:07,230 --> 00:02:11,030
закрити фігурну дужку, крапку з комою-- після того, як я визначив свій тип даних,

43
00:02:11,030 --> 00:02:15,680
Я можу ввести структуру car як car підкреслення t.

44
00:02:15,680 --> 00:02:19,670
І тоді, коли я це зробив, тепер кожного разу я б інакше використовував struct

45
00:02:19,670 --> 00:02:22,680
автомобіль, я можу просто використовувати підкреслення автомобіля t.

46
00:02:22,680 --> 00:02:26,480
Це набагато коротший спосіб виразити цю ідею цієї структури

47
00:02:26,480 --> 00:02:28,530
які я щойно створив.

48
00:02:28,530 --> 00:02:33,620
>> Крім того, оскільки структури дуже часто використовуються в typedef,

49
00:02:33,620 --> 00:02:37,980
є... ви насправді можете визначити тип між початком і кінцем.

50
00:02:37,980 --> 00:02:42,020
Отже, структура typedef зазвичай виглядає як typedef, стара назва, нова назва,

51
00:02:42,020 --> 00:02:45,360
де імена вже є типами, які ви створили.

52
00:02:45,360 --> 00:02:49,620
Але насправді ви можете визначити структуру прямо в середині typedef

53
00:02:49,620 --> 00:02:51,760
замість того, щоб визначати його окремо, а потім

54
00:02:51,760 --> 00:02:52,990
виконайте визначення типу.

55
00:02:52,990 --> 00:02:55,780
І це виглядало б так: typedef struct car,

56
00:02:55,780 --> 00:02:59,957
відкрити фігурну дужку, усі ваші визначення полів, закрити фігурну дужку, автомобіль t.

57
00:02:59,957 --> 00:03:03,290
Отже, стара назва — це все, що в червоному, ви просто визначаєте структуру

58
00:03:03,290 --> 00:03:05,610
і називати його одночасно.

59
00:03:05,610 --> 00:03:07,790
І тоді нова назва — car underscore t.

60
00:03:07,790 --> 00:03:10,150
І тому, якщо ми почнемо використовувати це в коді, раніше я

61
00:03:10,150 --> 00:03:13,279
міг би сказати, struct car mycar крапка з комою.

62
00:03:13,279 --> 00:03:14,820
Ну, мені більше не потрібно цього робити.

63
00:03:14,820 --> 00:03:20,265
Тепер, коли я використав typedef, я можу просто сказати car underscore t, mycar.

64
00:03:20,265 --> 00:03:22,640
Це набагато коротший спосіб зробити це, і насправді це так

65
00:03:22,640 --> 00:03:24,515
буде набагато зручніше, особливо

66
00:03:24,515 --> 00:03:27,730
коли ви починаєте набагато частіше використовувати структури у своєму коді.

67
00:03:27,730 --> 00:03:28,810
>> Я Дуг Ллойд.

68
00:03:28,810 --> 00:03:33,810
Це CS50.


